# Copyright (c) Microsoft Corporation.
# Licensed under the MIT license.

# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class DeleteDocumentsResponse(Model):
    """A response containing the status for a request to delete documents from the
    index.

    :param status: The status for the document deletion request. Possible
     values include: 'Succeeded', 'PartiallySucceeded', 'Failed'
    :type status: str or ~microsoft.bing.commerce.ingestion.models.enum
    :param error_message: An aggregation of error messages for errors that
     happened while processing the request, if any.
    :type error_message: str
    :param result: A list of status results per document.
    :type result:
     list[~microsoft.bing.commerce.ingestion.models.ResponseDocumentDeletionResult]
    """

    _attribute_map = {
        'status': {'key': 'status', 'type': 'str'},
        'error_message': {'key': 'errorMessage', 'type': 'str'},
        'result': {'key': 'result', 'type': '[ResponseDocumentDeletionResult]'},
    }

    def __init__(self, **kwargs):
        super(DeleteDocumentsResponse, self).__init__(**kwargs)
        self.status = kwargs.get('status', None)
        self.error_message = kwargs.get('error_message', None)
        self.result = kwargs.get('result', None)
