# Copyright (c) Microsoft Corporation.
# Licensed under the MIT license.

# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class ResponseRecordStatus(Model):
    """A response that represents a status to a push data update for a record.

    :param record_id: The _itemid for the record being updated.
    :type record_id: str
    :param status: The status for the push data update regarding the specified
     item id. Possible values include: 'InProgress', 'Succeeded',
     'PartiallySucceeded', 'Failed'
    :type status: str or ~microsoft.bing.commerce.ingestion.models.enum
    :param error_message: An optional error message in case of an error while
     ingesting the record.
    :type error_message: str
    """

    _attribute_map = {
        'record_id': {'key': 'recordId', 'type': 'str'},
        'status': {'key': 'status', 'type': 'str'},
        'error_message': {'key': 'errorMessage', 'type': 'str'},
    }

    def __init__(self, **kwargs):
        super(ResponseRecordStatus, self).__init__(**kwargs)
        self.record_id = kwargs.get('record_id', None)
        self.status = kwargs.get('status', None)
        self.error_message = kwargs.get('error_message', None)
