# Copyright (c) Microsoft Corporation.
# Licensed under the MIT license.

# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.
# --------------------------------------------------------------------------

from msrest.serialization import Model


class TransformationTryoutResponse(Model):
    """A response representing the status of a transformation config tryout
    requset.

    :param status: The status of the transformation config tryout.
    :type status: str
    :param error_message: Any error messages that happened while transforming,
     if any.
    :type error_message: str
    :param results: A list of records that the transformation config outputed.
    :type results: list[str]
    :param console_output: The console output of the transformation config, if
     any. Can be useful for debugging.
    :type console_output: list[str]
    """

    _attribute_map = {
        'status': {'key': 'status', 'type': 'str'},
        'error_message': {'key': 'errorMessage', 'type': 'str'},
        'results': {'key': 'results', 'type': '[str]'},
        'console_output': {'key': 'consoleOutput', 'type': '[str]'},
    }

    def __init__(self, *, status: str=None, error_message: str=None, results=None, console_output=None, **kwargs) -> None:
        super(TransformationTryoutResponse, self).__init__(**kwargs)
        self.status = status
        self.error_message = error_message
        self.results = results
        self.console_output = console_output
